LeetCode 292. Nim Game

来源:互联网 发布:ppsspp mac安装sdl2 编辑:程序博客网 时间:2024/05/07 06:54

292. Nim Game

Description

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.
Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.
For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

Solution

//该题就是Bash Game的一种特例,当m=3的时候。//首先我们注意到,如果n=4,那么无论先手取多少,后手总能将最后一个取得,那么如果n是4的倍数,可以按照这样的策略,使得最后剩下4个并且处于先手取的状态:后手每次取的数与先手取的数和总为4即可。//因此,我们只需要判断n是不是4的倍数即可,如果是4的倍数,那么后手必胜,代码如下bool canWinNim(int n) {    return n % 4 != 0;}
原创粉丝点击